local M = {}

--If you reload Lua with CTRL+L use thise in the GE console ` extensions["/levels/utah/mainLevel"].onClientStartMission() `

--In blacklist you put folders that have to be loaded from your map variant, if you want to load all folders leave blacklist empty/comment it

local levelOriginalFolder = "/levels/utah/"
local blacklist = {"forest","terrains"}

local function setAllLightsEnabled(group, value)
    for i = 0, group.obj:getCount(), 1 do
        local id = group.obj:idAt(i)
        local obj = scenetree.findObjectById(id)
        if obj and obj.obj:isSubClassOf('LightBase') then
            obj.obj:setLightEnabled( value )
        end
    end
end

local lastValue = nil

local function onUpdate()
    local tod = scenetree.tod
    if not tod then return end

    local value = false
    if tod.time > 0.21 and tod.time < 0.77 then
        value = true
    end

    if lastValue == value then return end
    lastValue = value

    if scenetree.auto_repair_lights then
      setAllLightsEnabled(scenetree.auto_repair_lights, value )
      setAllLightsEnabled(scenetree.tourist_center_lights, value )
      setAllLightsEnabled(scenetree.dealer_b_lights, value )
    end
end

local function onClientPreStartMission()
    log("I","onClientPreStartMission","Loading vanilla materials")
  
  
    -- Loading CS files (0.17 doesnt have any anymore)
    local files = FS:findFiles(levelOriginalFolder, 'materials.cs', -1, true, false)
    -- log("D","onClientPreStartMission","CS = "..dumps(files))
    for i,v in ipairs(files) do
        if not FS:fileExists(v) then goto continueCs end
        for _,b in ipairs(blacklist) do
            if v:find(b) then
                -- log("E","onClientPreStartMission","skipped = "..dumps(v))
                goto continueCs
            end
        end
        TorqueScript.exec(v)
        ::continueCs::
    end
  
    -- Loading new Json materials
    local materialfiles = FS:findFilesByPattern(levelOriginalFolder, "*materials.json", -1, true, false)
    -- log("D","onClientPreStartMission","json = "..dumps(materialfiles))
    for  _,v in pairs(materialfiles) do
        if not FS:fileExists(v) then goto continueJ end
        for _,b in ipairs(blacklist) do
            if v:find(b) then
                -- log("D","onClientPreStartMission","skipped = "..dumps(v))
                goto continueJ
            end
        end
        loadJsonMaterialsFile(v)
        ::continueJ::
    end
  
    -- Loading decals data after the materials are created
    TorqueScript.exec(levelOriginalFolder.."/art/decals/managedDecalData.cs")
    --TorqueScript.exec(levelOriginalFolder.."/From_east_coast_usa/decals/managedDecalData.cs")
    --TorqueScript.exec(levelOriginalFolder.."/From_driver_training/art/decals/managedDecalData.cs")
  
  end

M.onClientPreStartMission = onClientPreStartMission
M.onClientStartMission = onClientStartMission
M.onUpdate = onUpdate

return M